#version 330

uniform mat4 vp;

uniform vec3 vQuad1, vQuad2;

uniform float lifeTimeMax;

layout(points) in;
layout(triangle_strip) out;
layout(max_vertices = 4) out;

in vec3 colorPass[];
in float lifeTimePass[];
in float sizePass[];
in int typePass[];

smooth out vec2 texCoord;
flat out vec4 colorPart;

void main()
{
  if(typePass[0] != 0)
  {
    vec3 posOld = gl_in[0].gl_Position.xyz;
    float size = sizePass[0];
    
    colorPart = vec4(colorPass[0], lifeTimePass[0] / lifeTimeMax);
       
    vec3 pos = posOld+(-vQuad1-vQuad2)*size;
    texCoord = vec2(0.0, 0.0);
    gl_Position = vp*vec4(pos, 1.0);
    EmitVertex();
    
    pos = posOld+(-vQuad1+vQuad2)*size;
    texCoord = vec2(0.0, 1.0);
    gl_Position = vp*vec4(pos, 1.0);
    EmitVertex();
    
    pos = posOld+(vQuad1-vQuad2)*size;
    texCoord = vec2(1.0, 0.0);
    gl_Position = vp*vec4(pos, 1.0);
    EmitVertex();
    
    pos = posOld+(vQuad1+vQuad2)*size;
    texCoord = vec2(1.0, 1.0);
    gl_Position = vp*vec4(pos, 1.0);
    EmitVertex();
      
    EndPrimitive();
  }
}